data "aws_iam_policy_document" "eks_worker" {
  statement {
    actions = [
      "sts:AssumeRole",
    ]

    resources = ["*"]
  }
}

resource "aws_iam_policy" "eks_worker" {
  policy = "${data.aws_iam_policy_document.eks_worker.json}"
}

resource "aws_iam_role_policy_attachment" "eks_worker" {
  role       = "${var.worker_iam_role_name}"
  policy_arn = "${aws_iam_policy.eks_worker.arn}"
}

data "aws_iam_policy_document" "default" {
  statement {
    actions = [
      "sts:AssumeRole",
    ]

    principals {
      type        = "Service"
      identifiers = ["ec2.amazonaws.com"]
    }
  }

  statement {
    actions = [
      "sts:AssumeRole",
    ]

    principals {
      type        = "AWS"
      identifiers = ["${var.worker_iam_role_arn}"]
    }
  }
}

resource "aws_iam_role" "default" {
  name               = "eks-kube2iam-default-role"
  assume_role_policy = "${data.aws_iam_policy_document.default.json}"
}
